<?php
// Check
	if (!defined('MINIMUM_PHP_VERSION')) {
		define('MINIMUM_PHP_VERSION', 8.2);
	}
	if (!defined('DATA_TITLE_PREG')) {
		define('DATA_TITLE_PREG', '#^[a-z 0-9\-\_ ]+$#mi');
	}
	if (!defined('REDIRECT_PREG_REQS')) {
		define('REDIRECT_PREG_REQS', '#^[a-zA-Z0-9\-\_\./]+$#mi');
	}
	if (!defined('PATH_PREG_REQS')) {
		define('PATH_PREG_REQS', '#^[^/?*:;\\{}]+$#mi');
	}
	if (!defined('SIMPLE_NAME_PREG')) {
		define('SIMPLE_NAME_PREG', '#^[a-zA-Z0-9\-\_]+$#mi');
	}
	if (!defined('ALLOWED_IMAGE_UPLOAD_EXTENTIONS')) {
		define('ALLOWED_IMAGE_UPLOAD_EXTENTIONS', [".jpg",".jpeg",".gif",".png"]);
	}
	if (!defined('MINIMUM_PASSWORD_LENGTH')) {
		define('MINIMUM_PASSWORD_LENGTH', 8);
	}
	if (!defined('MAXIMUM_PASSWORD_LENGTH')) {
		define('MAXIMUM_PASSWORD_LENGTH', 24);
	}
	if (!defined('ADDITIONAL_PASSWORD_REGEX')) {
		// define('ADDITIONAL_PASSWORD_REGEX', '#^[a-z 0-9\-\_ ]+$#mi');
		define('ADDITIONAL_PASSWORD_REGEX', '#^[a-z0-9\~\_\+\=\.\,\<\>\(\)\#\?\!\@\$\%\^\&\*\-\ ]+$#mi');
	}
	if (!defined('SESSION_NAME_REGEX')) {
		define('SESSION_NAME_REGEX', '#^[a-zA-Z0-9\_\-]+$#mi');
	}
// Cookies
	if (!defined('DEFAULT_COOKIE_EXPIRATION')) {
		define('DEFAULT_COOKIE_EXPIRATION', 604800);
	}
	if (!defined('DEFAULT_COOKIE_PREFIX')) {
		define('DEFAULT_COOKIE_PREFIX', 'TTP_BEDROCK_');
	}
// Database
	if (!defined('MAX_RESULTS_PER_PAGE')) {
		define('MAX_RESULTS_PER_PAGE', 50);
	}
	if (!defined('DEFAULT_RESULTS_PER_PAGE')) {
		define('DEFAULT_RESULTS_PER_PAGE', 10);
	}
// Debug
    // Log Levels
	    if ( ! defined('CANARY_DEBUG_LEVEL_ERROR' ) ) {
	        define( 'CANARY_DEBUG_LEVEL_ERROR', 'error' );
	    }
	    if ( ! defined('CANARY_DEBUG_LEVEL_WARN' ) ) {
	        define( 'CANARY_DEBUG_LEVEL_WARN', 'warn' );
	    }
	    if ( ! defined('CANARY_DEBUG_LEVEL_INFO' ) ) {
	        define( 'CANARY_DEBUG_LEVEL_INFO', 'info' );
	    }
	    if ( ! defined('CANARY_DEBUG_LEVEL_LOG' ) ) {
	        define( 'CANARY_DEBUG_LEVEL_LOG', 'log' );
	    }
	    if ( ! defined('CANARY_DEBUG_LEVEL_DEBUG' ) ) {
	        define( 'CANARY_DEBUG_LEVEL_DEBUG', 'debug' );
	    }
	if (!defined('CANARY_ENABLED')) {
		define('CANARY_ENABLED', false);
	}
	if (!defined('BEDROCK_DEFAULT_ERROR_HANDLER')) {
		define('BEDROCK_DEFAULT_ERROR_HANDLER', 'TheTempusProject\\Canary\\Bin\\Canary');
	}
	if (!defined('BEDROCK_DEFAULT_EXCEPTION_HANDLER')) {
		define('BEDROCK_DEFAULT_EXCEPTION_HANDLER', 'TheTempusProject\\Canary\\Bin\\Canary');
	}
	if (!defined('DEBUG_EMAIL')) {
		define('DEBUG_EMAIL', 'webmaster@' . $_SERVER['HTTP_HOST']);
	}
	if (!defined('HERMES_REDIRECTS_ENABLED')) {
		define('HERMES_REDIRECTS_ENABLED', true);
	}
	if (!defined('RENDERING_ENABLED')) {
		define('RENDERING_ENABLED', true);
	}
	if (!defined('CANARY_TRACE_ENABLED')) {
		define('CANARY_TRACE_ENABLED', false);
	}
	if (!defined('CANARY_DEBUG_TO_CONSOLE')) {
		define('CANARY_DEBUG_TO_CONSOLE', false);
	}
	if (!defined('CANARY_DEBUG_TO_FILE')) {
		define('CANARY_DEBUG_TO_FILE', false);
	}
    if (!defined('CANARY_DEBUG_TO_FILE_LEVEL')) {
        define('CANARY_DEBUG_TO_FILE_LEVEL', CANARY_DEBUG_LEVEL_ERROR);
    }
// Directories
	if (!defined('BEDROCK_ROOT_DIRECTORY')) {
		define('BEDROCK_ROOT_DIRECTORY', dirname(__DIR__) . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_CONFIG_DIRECTORY')) {
		define('BEDROCK_CONFIG_DIRECTORY', BEDROCK_ROOT_DIRECTORY . 'config' . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_BIN_DIRECTORY')) {
		define('BEDROCK_BIN_DIRECTORY', BEDROCK_ROOT_DIRECTORY . 'bin' . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_RESOURCES_DIRECTORY')) {
		define('BEDROCK_RESOURCES_DIRECTORY', BEDROCK_ROOT_DIRECTORY . 'resources' . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_VIEW_DIRECTORY')) {
		define('BEDROCK_VIEW_DIRECTORY', BEDROCK_ROOT_DIRECTORY . 'views' . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_ERRORS_DIRECTORY')) {
		define('BEDROCK_ERRORS_DIRECTORY', BEDROCK_VIEW_DIRECTORY . 'errors' . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_CLASSES_DIRECTORY')) {
		define('BEDROCK_CLASSES_DIRECTORY', BEDROCK_ROOT_DIRECTORY . 'classes' . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_FUNCTIONS_DIRECTORY')) {
		define('BEDROCK_FUNCTIONS_DIRECTORY', BEDROCK_ROOT_DIRECTORY . 'functions' . DIRECTORY_SEPARATOR);
	}
	if (!defined('BEDROCK_CONFIG_JSON')) {
		define('BEDROCK_CONFIG_JSON', BEDROCK_CONFIG_DIRECTORY . 'config.json');
	}
// Files
	if (!defined('COMPOSER_JSON_LOCATION')) {
		define('COMPOSER_JSON_LOCATION', APP_ROOT_DIRECTORY . 'composer.json');
	}
	if (!defined('COMPOSER_LOCK_LOCATION')) {
		define('COMPOSER_LOCK_LOCATION', APP_ROOT_DIRECTORY . 'composer.lock');
	}
	if (!defined('CONFIG_JSON')) {
		define('CONFIG_JSON', CONFIG_DIRECTORY . 'config.json');
	}
// Other
	if (!defined('DEFAULT_CONTROLLER_CLASS')) {
		define('DEFAULT_CONTROLLER_CLASS', 'Home');
	}
	if (!defined('DEFAULT_CONTROLLER_METHOD')) {
		define('DEFAULT_CONTROLLER_METHOD', 'index');
	}
	if (!defined('EMAIL_FROM_EMAIL')) {
		define('EMAIL_FROM_EMAIL', 'noreply@' . $_SERVER['HTTP_HOST']);
	}
	if (!defined('DEFAULT_TIMEZONE')) {
		define('DEFAULT_TIMEZONE', "America/New_York");
	}
	if (!defined('DEFAULT_DATE_FORMAT')) {
		define('DEFAULT_DATE_FORMAT', "F j, Y");
	}
	if (!defined('DEFAULT_TIME_FORMAT')) {
		define('DEFAULT_TIME_FORMAT', "g:i:s A");
	}
// Random
	if (!defined('KB')) {
		define('KB', 1024);
	}
	if (!defined('MB')) {
		define('MB', 1048576);
	}
	if (!defined('GB')) {
		define('GB', 1073741824);
	}
	if (!defined('TB')) {
		define('TB', 1099511627776);
	}
// Sessions
	if (!defined('DEFAULT_SESSION_PREFIX')) {
		define('DEFAULT_SESSION_PREFIX', 'TTP_BEDROCK_');
	}
// Token
	if (!defined('DEFAULT_TOKEN_NAME')) {
		define('DEFAULT_TOKEN_NAME', 'TTP_BEDROCK_SESSION_TOKEN');
	}
	if (!defined('TOKEN_ENABLED')) {
		define('TOKEN_ENABLED', true);
	}
# Tell the app all constants have been loaded.
if ( ! defined('BEDROCK_CONSTANTS_LOADED' ) ) {
    define( 'BEDROCK_CONSTANTS_LOADED', true );
}